package cokr.xit.fims.sndb.dao;

import java.util.List;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.foundation.component.AbstractMapper;
import cokr.xit.foundation.data.DataObject;
import cokr.xit.fims.sndb.SndbQuery;
import cokr.xit.fims.sndb.Svbtc;

/** 공시송달 대장 정보 DAO
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-08-31	mjkhan 최초 작성
 * ================================
 * </pre>
 */
@Mapper("svbtcMapper")
public interface SvbtcMapper extends AbstractMapper {

	/**지정한 조건에 따라 공시송달 대장 목록을 조회하여 반환한다.<br />
	 * @param req 공시송달 대장 조회 조건
	 * @return 공시송달 대장 목록
	 */
	List<DataObject> selectSvbtcList(SndbQuery req);

	/**지정한 조건에 따라 공시송달 대장 객체들을 반환한다.
	 * @param req 공시송달 대장 조회 조건
	 * @return 공시송달 대장 객체 목록
	 */
	List<DataObject> selectSvbtcs(SndbQuery req);

	/**지정한 조건에 따라 공시송달 대장 객체의 마지막 1개를 반환한다.
	 * @param req 공시송달 대장 조회 조건
	 * @return 부과제외 대장 객체
	 */
	default DataObject selectSvbtcInfo(SndbQuery req) {
		// 삭제 여부
		if (req.getDelYn() == null) {
			req.setDelYn("N");
		}
		// 기본 정렬
		if (req.getOrderBy() == null) {
			req.setOrderBy("SV.SVBTC_ID DESC");
		}

		List<DataObject> svbtcs = selectSvbtcs(req);

		return !svbtcs.isEmpty() ? svbtcs.get(0) : null;
	}

	/**지정한 조건에 따라 공시송달 상세 목록을 조회하여 반환한다.<br />
	 * @param req 공시송달 대장 조회 조건
	 * @return 공시송달 대장 목록
	 */
	List<DataObject> selectSvbtcDtlList(SndbQuery req);

	/**지정한 조건에 따라 공시송달 상세 객체들을 반환한다.
	 * @param req 공시송달 대장 조회 조건
	 * @return 공시송달 대장 객체 목록
	 */
	List<DataObject> selectSvbtcDtls(SndbQuery req);

	/**지정한 조건에 따라 공시송달 상세 객체들을 반환한다.
	 * @param req 공시송달 대장 조회 조건
	 * @return 공시송달 대장 객체 목록
	 */
	List<DataObject> selectSvbtcPrint(SndbQuery req);

	/**공시송달 대장 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"svbtc" - 공시송달 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertSvbtc(Svbtc svbtc);

	/**공시송달 대장 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"svbtc" - 공시송달 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateSvbtc(Svbtc svbtc);

	/**지정한 공시송달 대장을 삭제한다.
	 * @param params 파라미터
	 * <ul><li>"svbtc" - 공시송달 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int deleteSvbtc(Svbtc svbtc);

}
